#ifndef BASE_MACHASH_H__
#define BASE_MACHASH_H__

// This exists solely because Mac OS X's hash implementation sucks:
// * It can't hash int64_t
// * It can't hash void*

#ifdef __APPLE__

namespace __gnu_cxx {

template <> class hash<int64_t> {
public:
    size_t operator()(const int64_t& v) const {
#ifdef __LP64__
        assert(sizeof(size_t) == sizeof(int64_t));
        return (size_t) v;
#else
        assert(sizeof(size_t) == 4);
        size_t h = (size_t) v;
        h ^= (size_t)(v >> 32);
        return h;
#endif
    }
};

template <> class hash<const void*> {
public:
    size_t operator()(const void* v) const {
        return (size_t) v;
    }
};

template <typename T> class hash<T*> : public hash<const void*> {};

}

#endif

#endif
