#ifndef DTXN_COMMON_H
#define DTXN_COMMON_H

// Utility functions shared by multiple dtxn implementations.
namespace dtxn {

class Coordinator;
class Partition;
class TransactionScheduler;

// Runs a server using scheduler for partition. This server is the replica numbered replica_index.
// scheduler will be deleted by this function.
void runServer(TransactionScheduler* scheduler, const Partition& partition, int replica_index);

// Runs a distributor using coordinator on port. coordinator will not be deleted by the function.
void runDistributor(Coordinator* coordinator, int port, const char* configuration_file);

}  // namespace dtxn

#endif
