/* AUTOMATICALLY GENERATED: DO NOT EDIT */
#ifndef HTABLE_MESSAGES_H
#define HTABLE_MESSAGES_H

#include <cassert>
#include <string>
#include <vector>

#include "base/assert.h"
#include "io/message.h"
#include "serialization.h"

namespace io {
class FIFOBuffer;
}

namespace htable {

// Contains a key and a value.
class KeyValuePair : public io::Message {
public:
    KeyValuePair() :
        hasValue(false) {}

    // Key name.
    std::string key;

    // True if this pair contains a value.
    bool hasValue;

    // Value for the key.
    std::string value;

    bool operator==(const KeyValuePair& other) const {
        if (key != other.key) return false;
        if (hasValue != other.hasValue) return false;
        if (value != other.value) return false;
        return true;
    }
    bool operator!=(const KeyValuePair& other) const { return !(*this == other); }

    void appendToString(std::string* _out_) const {
        serialization::serialize(key, _out_);
        serialization::serialize(hasValue, _out_);
        serialization::serialize(value, _out_);
    }

    virtual void serialize(io::FIFOBuffer* _out_) const {
        serialization::serialize(key, _out_);
        serialization::serialize(hasValue, _out_);
        serialization::serialize(value, _out_);
    }

    const char* parseFromString(const char* _start_, const char* _end_) {
        _start_ = serialization::deserialize(&key, _start_, _end_);
        _start_ = serialization::deserialize(&hasValue, _start_, _end_);
        _start_ = serialization::deserialize(&value, _start_, _end_);
        return _start_;
    }

    void parseFromString(const std::string& _str_) {
        const char* end = parseFromString(_str_.data(), _str_.data() + _str_.size());
        ASSERT(end == _str_.data() + _str_.size());
    }

    static int32_t typeCode() { return -971916225; }
};

// A mini-transaction.
class MiniTransaction : public io::Message {
public:
    MiniTransaction() {}

    // Key/Value pairs to compare.
    std::vector<KeyValuePair> compare_set;

    // Keys to read.
    std::vector<std::string> read_set;

    // Keys to write.
    std::vector<KeyValuePair> write_set;

    bool operator==(const MiniTransaction& other) const {
        if (compare_set != other.compare_set) return false;
        if (read_set != other.read_set) return false;
        if (write_set != other.write_set) return false;
        return true;
    }
    bool operator!=(const MiniTransaction& other) const { return !(*this == other); }

    void appendToString(std::string* _out_) const {
        {
            int32_t _size_ = static_cast<int32_t>(compare_set.size());
            assert(0 <= _size_ && static_cast<size_t>(_size_) == compare_set.size());
            serialization::serialize(_size_, _out_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                compare_set[_i_].appendToString(_out_);
            }
        }
        {
            int32_t _size_ = static_cast<int32_t>(read_set.size());
            assert(0 <= _size_ && static_cast<size_t>(_size_) == read_set.size());
            serialization::serialize(_size_, _out_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                serialization::serialize(read_set[_i_], _out_);
            }
        }
        {
            int32_t _size_ = static_cast<int32_t>(write_set.size());
            assert(0 <= _size_ && static_cast<size_t>(_size_) == write_set.size());
            serialization::serialize(_size_, _out_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                write_set[_i_].appendToString(_out_);
            }
        }
    }

    virtual void serialize(io::FIFOBuffer* _out_) const {
        {
            int32_t _size_ = static_cast<int32_t>(compare_set.size());
            assert(0 <= _size_ && static_cast<size_t>(_size_) == compare_set.size());
            serialization::serialize(_size_, _out_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                compare_set[_i_].serialize(_out_);
            }
        }
        {
            int32_t _size_ = static_cast<int32_t>(read_set.size());
            assert(0 <= _size_ && static_cast<size_t>(_size_) == read_set.size());
            serialization::serialize(_size_, _out_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                serialization::serialize(read_set[_i_], _out_);
            }
        }
        {
            int32_t _size_ = static_cast<int32_t>(write_set.size());
            assert(0 <= _size_ && static_cast<size_t>(_size_) == write_set.size());
            serialization::serialize(_size_, _out_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                write_set[_i_].serialize(_out_);
            }
        }
    }

    const char* parseFromString(const char* _start_, const char* _end_) {
        {
            int32_t _size_;
            _start_ = serialization::deserialize(&_size_, _start_, _end_);
            assert(_size_ >= 0);
            compare_set.resize(_size_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                _start_ = compare_set[_i_].parseFromString(_start_, _end_);
            }
        }
        {
            int32_t _size_;
            _start_ = serialization::deserialize(&_size_, _start_, _end_);
            assert(_size_ >= 0);
            read_set.resize(_size_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                _start_ = serialization::deserialize(&read_set[_i_], _start_, _end_);
            }
        }
        {
            int32_t _size_;
            _start_ = serialization::deserialize(&_size_, _start_, _end_);
            assert(_size_ >= 0);
            write_set.resize(_size_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                _start_ = write_set[_i_].parseFromString(_start_, _end_);
            }
        }
        return _start_;
    }

    void parseFromString(const std::string& _str_) {
        const char* end = parseFromString(_str_.data(), _str_.data() + _str_.size());
        ASSERT(end == _str_.data() + _str_.size());
    }

    static int32_t typeCode() { return -1130153967; }
};

// Result of executing a mini-transaction.
class MiniResult : public io::Message {
public:
    MiniResult() {}

    // Keys and values that were read.
    std::vector<KeyValuePair> keyvalues;

    bool operator==(const MiniResult& other) const {
        if (keyvalues != other.keyvalues) return false;
        return true;
    }
    bool operator!=(const MiniResult& other) const { return !(*this == other); }

    void appendToString(std::string* _out_) const {
        {
            int32_t _size_ = static_cast<int32_t>(keyvalues.size());
            assert(0 <= _size_ && static_cast<size_t>(_size_) == keyvalues.size());
            serialization::serialize(_size_, _out_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                keyvalues[_i_].appendToString(_out_);
            }
        }
    }

    virtual void serialize(io::FIFOBuffer* _out_) const {
        {
            int32_t _size_ = static_cast<int32_t>(keyvalues.size());
            assert(0 <= _size_ && static_cast<size_t>(_size_) == keyvalues.size());
            serialization::serialize(_size_, _out_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                keyvalues[_i_].serialize(_out_);
            }
        }
    }

    const char* parseFromString(const char* _start_, const char* _end_) {
        {
            int32_t _size_;
            _start_ = serialization::deserialize(&_size_, _start_, _end_);
            assert(_size_ >= 0);
            keyvalues.resize(_size_);
            for (int _i_ = 0; _i_ < _size_; ++_i_) {
                _start_ = keyvalues[_i_].parseFromString(_start_, _end_);
            }
        }
        return _start_;
    }

    void parseFromString(const std::string& _str_) {
        const char* end = parseFromString(_str_.data(), _str_.data() + _str_.size());
        ASSERT(end == _str_.data() + _str_.size());
    }

    static int32_t typeCode() { return -1094725957; }
};

}  // namespace htable
#endif  // HTABLE_MESSAGES_H
