#!/usr/bin/python

from stupidcompiler import *

pair = MessageDefinition("KeyValuePair", "Contains a key and a value.")
pair.addField(STRING, "key", None, "Key name.")
pair.addField(BOOL, "hasValue", False, "True if this pair contains a value.")
pair.addField(STRING, "value", None, "Value for the key.")

minitransaction = MessageDefinition("MiniTransaction", "A mini-transaction.")
minitransaction.addField(List(pair), "compare_set", None, "Key/Value pairs to compare.")
minitransaction.addField(List(STRING), "read_set", None, "Keys to read.")
minitransaction.addField(List(pair), "write_set", None, "Keys to write.")

miniresult = MessageDefinition("MiniResult", "Result of executing a mini-transaction.")
miniresult.addField(List(pair), "keyvalues", None, "Keys and values that were read.")

if __name__ == "__main__":
    main([pair, minitransaction, miniresult], "htable")
