#!/usr/bin/python

import unittest

import dataextract

class ExpandRowsTest(unittest.TestCase):
    def testPassThrough(self):
        data = [
                [0, 100],
                [10, 90],
                [20, 80],
        ]

        out = dataextract.expandRows(data, [0], [1])
        self.assertEquals(data, out)

    def testExpand(self):
        data = [
            [0, 100, 50],
            [10, 90, 40],
            [20, 80, 30],
        ]

        out = dataextract.expandRows(data, [0], [1, 2])
        
        expected = [
            [0, 100],
            [0, 50],
            [10, 90],
            [10, 40],
            [20, 80],
            [20, 30],
        ]
        self.assertEquals(expected, out)


if __name__ == "__main__":
    unittest.main()
