#!/usr/bin/python

"""
Configurations TODO:

* client -> 1 server: scale number of pending txns
* client -> distributor -> 1 server: 100% SP, scale number of pending txns
* client -> distributor -> 1 server: mix of SP and "multi-partition" (shows "overhead")
* client -> distributor -> 2 servers, 1 core: shows messaging overhead
* client -> distributor -> 2 servers: scale % MP txns
"""

import csv
import subprocess
import sys

PERF = "build/htableclientperf"
CONFIG = "farm-%d.conf"
DISTRIBUTOR = "localhost:12345"

TRIALS = 20
MAX_PARTITIONS = 7
THREADS = 4

if __name__ == "__main__":
    results = []
    for i in range(1, MAX_PARTITIONS+1):
        # 10 transactions per partition
        dispatch = i * 10
        config = CONFIG % i

        row = [i]
        print i, "partitions", 
        sys.stdout.flush()
        for x in range(TRIALS):
            child = subprocess.Popen((PERF, DISTRIBUTOR, config, str(dispatch), str(THREADS), "0"), stdout=subprocess.PIPE)
            output = child.stdout.read()
            result = child.wait()
            assert result == 0

            output = float(output.strip())
            row.append(output)
            print "\t", row[-1],
            sys.stdout.flush()
        results.append(row)
        print

    out = open("partitions.csv", "wb")
    writer = csv.writer(out)
    writer.writerows(results)
    out.close()
