#!/usr/bin/python

import csv
import subprocess
import sys

PERF = "build/htableclientperf"
CONFIG = "s-%d.conf"

TRIALS = 2
MAX_PARTITIONS = 4
THREADS = 4

if __name__ == "__main__":
    results = []
    for i in range(1, MAX_PARTITIONS+1):
        # 10 transactions per partition
        dispatch = i * 10
        config = CONFIG % i

        row = [i]
        print i, "partitions", 
        sys.stdout.flush()
        for x in range(TRIALS):
            child = subprocess.Popen((PERF, config, str(dispatch), str(THREADS)), stdout=subprocess.PIPE)
            output = child.stdout.read()
            result = child.wait()
            assert result == 0

            output = float(output.strip())
            row.append(output)
            print "\t", row[-1],
            sys.stdout.flush()
        results.append(row)
        print

    out = open("out.csv", "wb")
    writer = csv.writer(out)
    writer.writerows(results)
    out.close()
