#!/usr/bin/python

import sqlite3

import dataextract
import plot_line_average
import stupidplot


def foo(path):
    # Read in the table
    table = dataextract.readCSVTable(path)

    # Expand each repeated data point
    table = dataextract.expandRows(table, [0, 1], [2, 3, 4])
    table.insert(0, ["partitions", "multipartition_percent", "txns_per_sec"])

    connection = sqlite3.connect(":memory:")
    c = connection.cursor()

    # Create the table
    c.execute("create table results (%s);" % (", ".join(table[0])))

    # Import the data
    insert_template = "?," * len(table[0])
    insert_template = "insert into results values (%s)" % (insert_template[:-1])
    print insert_template
    for row in table[1:]:
        c.execute(insert_template, row)

    datasets = []
    for v in list(c.execute("select distinct multipartition_percent from results")):
        multipartition_percent = v[0]
        table = [["CPUs", "%d%% Multipartition" % (multipartition_percent), "- conf", "+ conf"]]
        for y in list(c.execute("select distinct partitions from results where "
                "multipartition_percent = ? order by partitions asc", [multipartition_percent])):
            y = y[0]
            x_values = []
            for x in c.execute("select txns_per_sec from results where partitions = ? and multipartition_percent = ?", (y, multipartition_percent)):
                x_values.append(x[0])
        
            stats = stupidplot.stats(x_values)
            table.append([y, stats[0], stats[0]-stats[-1], stats[0]+stats[-1]])
            print table[-1]
        datasets.append(table)
    
    return datasets


if __name__ == "__main__":
    import sys

    datasets = []
    for path in sys.argv[1:-1]:
        datasets.extend(foo(path))

    plot_line_average.plotAverage(datasets, sys.argv[-1])
