#!/usr/bin/python

import csv
import sys

import stupidplot

if __name__ == "__main__":
    data = open(sys.argv[1])
    reader = csv.reader(data)
    table = []
    for row in reader:
        table.append(row)
    data.close()

    average = [('Partition', 'Transactions/s', '-95% confidence', '+95% confidence')]
    scatter = [('Partitions', 'Transactions/s')]
    for row in table:
        x = row[0]
        for y in row[1:]:
            scatter.append((x, y))

        stats = stupidplot.stats([float(s) for s in row[1:]])
        average.append((x, stats[0], stats[0] - stats[-1], stats[0] + stats[-1]))
        print average[-1]

    options = {
        'plottype': 'points',
        'key': False,
        'ylabel': scatter[0][1],
        'yformat': '%g',
        'xformat': '%g',
        'xrange' : "[0:]",
    }
    stupidplot.gnuplotTable(scatter, "partitions-scatter.eps", options)

    options = {
        #~ 'plottype': 'points',
        'key': False,
        'ylabel': average[0][1],
        'errorbars': [1],
        'yformat': '%g',
        'xformat': '%g',
        'xrange' : "[0:]",
    }
    stupidplot.gnuplotTable(average, "partitions-average.eps", options)
