#!/usr/bin/python

"""
Configurations TODO:

* client -> 1 server: scale number of pending txns
* client -> distributor -> 1 server: 100% SP, scale number of pending txns
* client -> distributor -> 1 server: mix of SP and "multi-partition" (shows "overhead")
* client -> distributor -> 2 servers, 1 core: shows messaging overhead
* client -> distributor -> 2 servers: scale % MP txns
"""

import sys

import scale_mptxns

TRIALS = 3


def runTest(configuration_file, distributor):
    results = []

    percent_multipartition = 0
    for dispatch in range(1, 11) + range(12, 41, 2):
        row = [dispatch]
        print "%d" % row[0],
        sys.stdout.flush()
        for _ in range(TRIALS):
            threads = dispatch
            percent_multipartition = 0
            output = scale_mptxns.clientPerf(
                    distributor, configuration_file, dispatch, threads, percent_multipartition)
            row.append(output)
            print "\t", row[-1],
            sys.stdout.flush()
        results.append(row)
        print

    scale_mptxns.saveCSVResults(configuration_file, results)


if __name__ == "__main__":
    if len(sys.argv) != 3:
        sys.stderr.write("scale_clients.py [config file] [distributor]\n")
        sys.exit(1)

    configuration_file = sys.argv[1]
    distributor = sys.argv[2]

    runTest(configuration_file, distributor)
