#!/bin/sh
#
# A dumb script for running all the unit tests.
# TODO: Add unit test support to stupidbuild.

WRAPPER=./valleak.py

if [ `uname` = "Darwin" ]; then
    # Valgrind does not exist on Mac OS X but there are memory debugging options
    WRAPPER=""
    export MallocGuardEdges=1
    export MallocScribble=1
    export MallocErrorAbort=1
fi

for i in `find build -type f | grep "_test$"`; do
    # NOTE: This will not cause errors to occur if there are memory leaks!
    ${WRAPPER} ${i}
    if [ "$?" -ne "0" ]; then
        printf "\n\nFAILED: $i\n" > /dev/stderr
        exit
    fi
done

if [ `uname` = "Darwin" ]; then
    unset MallocGuardEdges
    unset MallocScribble
    unset MallocErrorAbort
fi

# Run the Python unit tests
for i in `find . -type f | grep "_test.py$"`; do
    PYTHONPATH=. ${i}
    if [ "$?" -ne "0" ]; then
        printf "\n\nFAILED: $i\n" > /dev/stderr
        exit
    fi
done

# Run pychecker
for i in `find . -type f | grep ".py$" | grep -v '^./third_party/.*' | grep -v '^./libevent/.*'`; do
    PYTHONPATH=. pychecker --stdlib ${i}
    if [ "$?" -ne "0" ]; then
        printf "\n\npychecker FAILED: $i\n" > /dev/stderr
        exit
    fi
done
