// Copyright 2008,2009,2010 Massachusetts Institute of Technology.
// All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

#ifndef HTABLEENGINE_H__
#define HTABLEENGINE_H__

#include "dtxn/executionengine.h"
#include "minitransactions/keyvalueengine.h"

namespace htable {

// TODO: Add unit tests for this!
class HTableEngine : public dtxn::ExecutionEngine {
public:
    HTableEngine(bool locking);

    virtual Status tryExecute(const std::string& work_unit, std::string* output, void** undo,
            dtxn::Transaction* transaction);
    virtual bool supports_locks() const { return locking_; }
    virtual void applyUndo(void* undo);
    virtual void freeUndo(void* undo);

    void print() const { engine_.print(); }

private:
    /** Parses the string into a MiniTransaction. */
    void parseFromString(const std::string& data, minitransactions::MiniTransaction* output);

    bool locking_;
    minitransactions::KeyValueEngine engine_;
};

}  // namespace htable
#endif
