#!/usr/bin/python

import mptxn

if __name__ == "__main__":
    slaves = mptxn.Slaves("taskmgrconfigs/task_conflicts.py")
    slaves.start()

    # Run each test
    for test_mode in ("conflict", "abort"):        
        if test_mode == "abort":
            # TODO: We should run all modes, but it really only matters for spec, and
            # it takes ~8 hours for each run.
            #~ server_modes = ("block", "spec", "lock")
            server_modes = ("spec",)
        else:
            server_modes = ("lock",)

        for server_mode in server_modes:
            print "starting %s %s test ..." % (test_mode, server_mode)
            slaves.taskcmd(("start", "--task_args", test_mode, server_mode))

            # Wait for the test to finish
            print "waiting for test to finish ..."
            slaves.wait((test_mode, server_mode))

            print "copying results ..."
            slaves.copyResults("data/%s-%s.csv" % (test_mode, server_mode))

            print "stopping test ..."
            slaves.taskcmd(("stop", "--task_args", test_mode, server_mode))

    # Stop the slaves
    slaves.stop()
