#!/usr/bin/python

import unittest

import dataextract


class ExpandRowsTest(unittest.TestCase):
    def testPassThrough(self):
        data = [
                [0, 100],
                [10, 90],
                [20, 80],
        ]

        out = dataextract.expandRows(data, [0], [1])
        self.assertEquals(data, out)

    def testExpand(self):
        data = [
            [0, 100, 50],
            [10, 90, 40],
            [20, 80, 30],
        ]

        out = dataextract.expandRows(data, [0], [1, 2])
        
        expected = [
            [0, 100],
            [0, 50],
            [10, 90],
            [10, 40],
            [20, 80],
            [20, 30],
        ]
        self.assertEquals(expected, out)


SAMPLE_DATA = [
        [0, 1],
        [2, 3],
]


class InsertColumnTest(unittest.TestCase):
    def testSimple(self):
        out = dataextract.insertColumn(SAMPLE_DATA, 1, "foo")
        self.assertEquals([0, "foo", 1], out[0])
        self.assertEquals([2, "foo", 3], out[1])


class ProjectTest(unittest.TestCase):
    def testSimple(self):
        self.assertRaises(IndexError, dataextract.project, SAMPLE_DATA, [2])
        out = dataextract.project(SAMPLE_DATA, [1])
        self.assertEquals([1], out[0])
        self.assertEquals([3], out[1])


if __name__ == "__main__":
    unittest.main()
