#!/usr/bin/python

import os.path

import dataextract
import stupidplot


def plotScatter(scatter_data, output_path):
    options = {
        'plottype': 'points',
        'key': False,
        #~ 'ylabel': scatter_block[0][1],
        'yformat': '%g',
        'xformat': '%g',
    }
    stupidplot.gnuplotTable(scatter_data, output_path, options)


def plotAverage(average_data, output_path):
    options = {
        #~ 'plottype': 'points',
        #~ 'key': False,
        #~ 'ylabel': 'Transactions/s',
        'errorbars': [1],
        'yformat': '%g',
        'xformat': '%g',
        #~ 'xrange' : "[0:]",
        'yrange' : "[0:]",
    }
    stupidplot.gnuplotTable(average_data, output_path, options)


if __name__ == "__main__":
    import sys

    if len(sys.argv) == 2:
        average, scatter = dataextract.extractTables(
                sys.argv[1], "X-Axis Values", "Transactions/second", sys.argv[1])
        for row in average:
            print "\t".join((str(v) for v in row))
        sys.exit(0)

    if len(sys.argv) < 3:
        sys.stderr.write("plot_line_average.py [input files] [output.eps]\n")
        sys.exit(1)
    input_files = sys.argv[1:-1]
    output_file = sys.argv[-1]

    if os.path.exists(output_file):
        sys.stderr.write("output file %s exists: refusing to overwrite\n" % (sys.argv[-1]))
        sys.exit(1)

    averages = []
    for in_file in input_files:
        average = dataextract.readCSVTable(in_file)
        average.insert(0, ["X-Axis Values", in_file])
        #~ average, scatter = extractTables(in_file, "X-Axis Values", "Transactions/second", in_file)
        averages.append(average)

    plotAverage(averages, output_file)
