#!/usr/bin/python

"""
Configurations TODO:

* client -> 1 server: scale number of pending txns
* client -> distributor -> 1 server: 100% SP, scale number of pending txns
* client -> distributor -> 1 server: mix of SP and "multi-partition" (shows "overhead")
* client -> distributor -> 2 servers, 1 core: shows messaging overhead
* client -> distributor -> 2 servers: scale % MP txns
"""

import csv
import subprocess
import sys

PERF = "build/htableclientperf"
CONFIG = "s-2.conf"
DISTRIBUTOR = "localhost:12347"

TRIALS = 10
THREADS = 1

if __name__ == "__main__":
    results = []

    partitions = 1
    percent_multipartition = 100
    for dispatch in range(1, 21):
        row = [dispatch]
        print "%d" % row[0], 
        sys.stdout.flush()
        for x in range(TRIALS):
            child = subprocess.Popen((PERF, DISTRIBUTOR, CONFIG, str(dispatch), str(THREADS), str(percent_multipartition)), stdout=subprocess.PIPE)
            output = child.stdout.read()
            result = child.wait()
            assert result == 0

            output = float(output.strip())
            row.append(output)
            print "\t", row[-1],
            sys.stdout.flush()
        results.append(row)
        print

    out = open("clients-mptxn.csv", "wb")
    writer = csv.writer(out)
    writer.writerows(results)
    out.close()
