// Copyright 2008,2009,2010 Massachusetts Institute of Technology.
// All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

#include "replication/nulllog.h"

#include "io/buffer.h"
#include "io/message.h"

namespace replication {

NullLog::~NullLog() {}

int NullLog::submit(const io::Message& entry, void* callback_arg) {
    io::FIFOBuffer buffer;
    entry.serialize(&buffer);
    std::string serialized_entry;
    buffer.copyOut(&serialized_entry, buffer.available());
    nextLogEntryCallback(sequence_, serialized_entry, callback_arg);
    int sequence = sequence_;
    sequence_ += 1;
    return sequence;
}

void NullLog::setCallbackArg(int sequence, void* callback_arg) {
    assert(false);
}

bool NullLog::isPrimary() const {
    return true;
}

void NullLog::flush() {}

}
