#!/bin/sh
#
# Makes a .tar.bz2 archive that can be expanded and executed in place.
# scp taskmgr_local.tar.bz2 login.csail.mit.edu:public_html

set -e

TEMPDIR=`mktemp -d -t taskmgr-build.XXXXXX`

# Copy the scripts
mkdir -p $TEMPDIR/taskmgr_slave
cp taskmgr_slave.py $TEMPDIR/taskmgr_slave
cp -r taskmgr $TEMPDIR/taskmgr_slave
cp -r third_party $TEMPDIR/taskmgr_slave

# Remove compiled scripts
find $TEMPDIR | grep '\.pyc$' | xargs --no-run-if-empty rm
find $TEMPDIR | grep '\.pyo$' | xargs --no-run-if-empty rm
# Remove test scripts
find $TEMPDIR | grep '_test\.py$' | xargs --no-run-if-empty rm

# Make the tar archive
CURRENT=`pwd`
cd $TEMPDIR && tar cvjf $CURRENT/taskmgr_local.tar.bz2 --owner=root --group=0 *

rm -rf $TEMPDIR
