#!/bin/sh
#
# Makes a planetlab .tar.bz2 archive: expand it in the root directory to install.

set -e

TEMPDIR=`mktemp -d -t taskmgr-build.XXXXXX`

# Copy the init script
mkdir -p $TEMPDIR/etc/init.d
cp taskmgr_slave.sh $TEMPDIR/etc/init.d/taskmgr_slave

# Copy the scripts
mkdir -p $TEMPDIR/usr/local/bin
cp taskmgr_slave.py $TEMPDIR/usr/local/bin
cp -r taskmgr $TEMPDIR/usr/local/bin
cp -r third_party $TEMPDIR/usr/local/bin

# Remove compiled scripts
find $TEMPDIR/usr/local/bin | grep '\.pyc$' | xargs --no-run-if-empty rm
find $TEMPDIR/usr/local/bin | grep '\.pyo$' | xargs --no-run-if-empty rm
# Remove test scripts
find $TEMPDIR | grep '_test\.py$' | xargs --no-run-if-empty rm

# Make the tar archive
CURRENT=`pwd`
cd $TEMPDIR && tar cvjf $CURRENT/taskmgr_slave.tar.bz2 --owner=root --group=0 *

rm -rf $TEMPDIR
