#!/usr/bin/python

#~ import cStringIO
#~ import os.path
#~ import signal
#~ from third_party.stdlib import tarfile  # local version
#~ import time
import shutil
import tempfile
import unittest

import taskcmd


class TaskcmdTest(unittest.TestCase):
    def testImportPath(self):
        temp_path = tempfile.mkdtemp()
        try:
            # Create a Python module
            out = open(temp_path + "/importtest.py", "w")
            out.write("#!/usr/bin/python\nfoobar = ['localhost:12345']\n")
            out.close()

            # Create a script that imports test
            out = open(temp_path + "/script.py", "w")
            out.write("""#!/usr/bin/python

import importtest
HOST_LIST = importtest.foobar

def scheduleTasks(scheduler, task_args):
    assert scheduler is not None
    assert len(task_args) == 0
    pass\n""")
            out.close()

            # parse the script
            command_hosts = ["localhost"]
            command_port = 55555
            task_args = []
            hosts, tasks = taskcmd.parseScript(temp_path + "/script.py",
                    command_hosts, command_port, task_args)
        finally:
            shutil.rmtree(temp_path)


class TaskSchedulerTest(unittest.TestCase):
    def testSchedule(self):
        scheduler = taskcmd.TaskScheduler(["host1:12345", "host2:12345"])
        host = scheduler.schedule(("command", "arg"), "package")
        self.assertEquals("host1", host)


if __name__ == "__main__":
    unittest.main()
