#!/usr/bin/python

import task

class Slave(object):
    def __init__(self):
        self.tasks = {}
        self.next_id = 0

    def taskStart(self, command, package_data):
        try:
            task_id = self.next_id
            self.next_id += 1
            self.tasks[task_id] = task.Task(command, package_data)

            return task_id 
        except:
            import sys
            import traceback
            traceback.print_exc(sys.exc_info()[2])
            raise

    def taskState(self, task_id):
        return self.tasks[task_id].poll()

    def taskOutput(self, task_id):
        return self.tasks[task_id].output()

    def taskStop(self, task_id):
        code = self.tasks[task_id].stop()
        del self.tasks[task_id]
        return code

    def taskList(self):
        tasks = []
        for task_id, task in self.tasks.iteritems():
            tasks.append((task_id, task.command, task.status()))
        return tasks

    def taskWait(self, task_id):
        task = self.tasks[task_id]
        code = task.wait()
        output = task.output()
        return code, output

    def shutdown(self):
        """Stop all running tasks."""

        for task in self.tasks.itervalues():
            task.stop()
        self.tasks = None
