#!/usr/bin/python

import sys
import xmlrpclib

import taskmgr.task

def convertArgs(args):
    out_args = []
    for arg in args:
        try:
            # Try to convert to an integer
            out_args.append(int(arg))
        except ValueError:
            out_args.append(arg)
    return out_args


if __name__ == "__main__":
    if len(sys.argv) < 3:
        sys.stderr.write("taskmgr_client.py [host:port] [command] [arguments]\n")
        sys.exit(1)
    host = sys.argv[1]
    command = sys.argv[2]

    server = xmlrpclib.ServerProxy("http://" + host)

    if command == "start":
        if len(sys.argv) < 4:
            sys.stderr.write("taskmgr_client.py [host:port] start [command line] [package contents]\n")
            sys.exit(1)
        command_line = sys.argv[3]
        package_contents = sys.argv[4:]

        # Build the tar archive
        package_data = taskmgr.task.makeTarFromFiles(package_contents)

        # Start the task
        task_id = server.taskStart(command_line, xmlrpclib.Binary(package_data))

        print "Job started with task_id", task_id
    else:
        dynamic_call = getattr(server, sys.argv[2])
        print dynamic_call(*convertArgs(sys.argv[3:]))
