#!/usr/bin/python

import os.path

import taskmgr.task

import task_mptxn
import task_tpcc_warehouses

def scheduleClient(scheduler, client_command, config):
    client_package = taskmgr.task.makeTarFromFiles([
        task_mptxn.SOURCE_PATH + "/build/tpccclientperf",
        task_mptxn.LOCK_SOURCE_PATH + "/build/tpccclientperf-lock",
        task_mptxn.SOURCE_PATH + "/perfscripts/frange.py",
        task_mptxn.SOURCE_PATH + "/perfscripts/scale_tpcc_mptxns.py",
        config.name], {
        task_mptxn.SOURCE_PATH + "/third_party/__init__.py": "third_party/__init__.py",
        task_mptxn.SOURCE_PATH + "/third_party/pystdlib": "third_party/pystdlib",
    })
    client_host = scheduler.schedule(client_command, client_package)
    return client_host


def scheduleTasks(scheduler, args):
    mode, warehouses, config, distributor_host = task_tpcc_warehouses.startTpcc(scheduler, args)

    client_command = ("./scale_tpcc_mptxns.py", "%s:%d" % (distributor_host, task_mptxn.PORT),
            os.path.basename(config.name), mode, str(warehouses))
    scheduleClient(scheduler, client_command, config)
