#!/usr/bin/python

import csv
import os
import subprocess
import sys
import time

TASKCMD="/home/evanj/taskmgr/taskcmd.py"
TASK_SCRIPT="farm_tpcc.py"

WAREHOUSE_FILENAME = "num_warehouses.tmp"

# It takes 40 seconds to load 10 warehouses (20 across 2 partitions)
DELAY_PER_WAREHOUSE = 40/10

MAX_WAREHOUSES = 20
TRIALS = 3


def command(command_string, farm_index):
    return (TASKCMD, TASK_SCRIPT, command_string, "farm%d.csail.mit.edu" % farm_index)


def start(farm_index):
    subprocess.check_call(command("start", farm_index), stdout=subprocess.PIPE)

 
results = [["Warehouses", "Transactions/s"]]
for warehouses in xrange(2, MAX_WAREHOUSES+1, 2):
    row = [warehouses]
    print warehouses,
    sys.stdout.flush()
    for trial in xrange(TRIALS):
        # HACK to change the number of warehouses
        o = open(WAREHOUSE_FILENAME, "w")
        o.write(str(warehouses))
        o.close()

        for farm_index in (6, 8, 5, 7):
            start(farm_index)
        # Wait for servers to load the data
        time.sleep(DELAY_PER_WAREHOUSE * warehouses / 2)
        for farm_index in (9, 10):
            start(farm_index)

        os.unlink(WAREHOUSE_FILENAME)

        # Capture the output
        wait_process = subprocess.Popen(command("wait", 10), stdout=subprocess.PIPE)
        output = wait_process.stdout.read()
        code = wait_process.wait()
        assert code == 0

        txns_per_second = float(output)
        row.append(txns_per_second)
        print txns_per_second,
        sys.stdout.flush()

        # Stop everything
        subprocess.check_call(command("stop", 0)[:-1], stdout=subprocess.PIPE)
    results.append(row)
    print

out = open("tpcc.csv", "wb")
writer = csv.writer(out)
writer.writerows(results)
out.close()
