#!/usr/bin/python

import mptxn
import tpcc_warehouses

WAREHOUSES = 6


if __name__ == "__main__":
    slaves = mptxn.Slaves("taskmgrconfigs/task_tpcc_mptxn.py")
    slaves.start()

    # Run each test
    for mode in ("block", "spec", "lock"):
        tpcc_warehouses.tpccStart(slaves, mode, WAREHOUSES)

        # Wait for the test to finish
        slaves.wait((mode, str(WAREHOUSES)))

        # Copy results
        slaves.copyResults("data/tpcc-mptxn-" + mode + ".csv")

        # Stop tasks
        slaves.taskcmd(("stop", "--task_args", mode, str(WAREHOUSES)))

    # Stop the slaves
    slaves.stop()
