#!/usr/bin/python

import dataextract
import mptxn_plot
import stupidplot

INPUTS = [
    ["data/tpcc-mptxn-spec.csv", "Speculation"],
    ["data/tpcc-mptxn-block.csv", "Blocking"],
    ["data/tpcc-mptxn-lock.csv", "Locking"],
]

if __name__ == "__main__":
    output_path = mptxn_plot.get_output()

    averages = []
    for path, line_title in INPUTS:
        average, scatter = dataextract.extractTables(path, mptxn_plot.X_AXIS, mptxn_plot.Y_AXIS, line_title)
        averages.append(mptxn_plot.removeErrorBars(average))

    stupidplot.gnuplotTable(averages, output_path, mptxn_plot.DEFAULT_PLOT_OPTIONS)
