#!/usr/bin/python

import dataextract
import mptxn_plot
import stupidplot

INPUTS = [
    ["data/tpcc-warehouses-spec.csv", "Speculation"],
    ["data/tpcc-warehouses-block.csv", "Blocking"],
    ["data/tpcc-warehouses-lock.csv", "Locking"],
]

X_AXIS = "Warehouses"

if __name__ == "__main__":
    output_path = mptxn_plot.get_output()

    averages = []
    for path, line_title in INPUTS:
        average, scatter = dataextract.extractTables(path, X_AXIS, mptxn_plot.Y_AXIS, line_title)
        averages.append(mptxn_plot.removeErrorBars(average))

    options = dict(mptxn_plot.DEFAULT_PLOT_OPTIONS)
    options["xformat"] = "%.0f"
    options["key"] = "bottom right"
    stupidplot.gnuplotTable(averages, output_path, options)

    # Generate OCC
    #~ average, scatter = plotutil.extractTables(OCC[0], X_AXIS, scale_mptxns.Y_AXIS, OCC[1])
    #~ averages.append(plotutil.removeErrorBars(average))
    #~ stupidplot.gnuplotTable(averages, output_path[:-4] + "-occ.eps", options)
